freeslot("MT_DISPENSER", "MT_SENTRY", "MT_TP_START", "MT_TP_END", "MT_MARKER", "MT_BUILD_BOX") //MT_ Objects
for i = 1, 4
	freeslot("SPR_SEN"..i, "SPR_DIS"..i, "SPR_TP__", "SPR_UPGR", "SPR_MARK", "SPR_BBOX") //Sprites
	freeslot("S_DISPENSER", "S_SENTRY_"..i, "S_TP_"..i,"S_MARK_ARROW", "S_MARK_B"..i, "S_MARK_RET", "S_BUILD_BOX")  //S_ States
end	
freeslot("S_TP_1E", "S_SEN_BOOST", "SPR_SENB", "SPR_RESP", "S_RESCUERANGERMISSILETHING", "S_HAULED", "SPR_HAUL", "S_WRENCH_WEP", "S_WRANG_WEP", "S_RESCUE_WEP", "S_BUILD_WEP", "S_DESTR_WEP", "S_BOX_WEP", "MT_WEAPON")
freeslot("sfx_intp","sfx_disap","sfx_budfin", "sfx_disexp", "sfx_senexp", "sfx_tpexp", "sfx_genmet", "sfx_dishel", "sfx_disstd", "sfx_senalr", "sfx_senroc", "sfx_tpspn", "sfx_tpred", "sfx_tpsed", "sfx_tpgot")
for i = 1, 8
	freeslot("sfx_tool"..i)
end
local hitgrd = {
sfx_tool1,
sfx_tool2,
sfx_tool3,
sfx_tool4,
sfx_tool5,
sfx_tool6,
sfx_tool7,
sfx_tool8}
mobjinfo[MT_BUILD_BOX] = {
	doomednum = -1,
	spawnstate = S_BUILD_BOX,
	spawnhealth = 3,
	speed = FRACUNIT*15,
	radius = 50*FRACUNIT,
	height = 20*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

mobjinfo[MT_MARKER] = {
	doomednum = -1,
	spawnstate = S_MARK_ARROW,
	spawnhealth = 1,
	speed = FRACUNIT*10,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

mobjinfo[MT_SENTRY] = {
	doomednum = -1,
	spawnstate = S_SENTRY_1,
	spawnhealth = 3,
	speed = FRACUNIT*30,
	radius = 15*FRACUNIT,
	height = 50*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

mobjinfo[MT_DISPENSER] = {
	doomednum = -1,
	spawnstate = S_DISPENSER,
	spawnhealth = 3,
	speed = FRACUNIT*30,
	radius = 24*FRACUNIT,
	height = 50*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

mobjinfo[MT_TP_START] = {
	doomednum = -1,
	spawnstate = S_TP_2,
	spawnhealth = 2,
	speed = FRACUNIT*30,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

mobjinfo[MT_TP_END] = {
	doomednum = -1,
	spawnstate = S_TP_2,
	spawnhealth = 2,
	speed = FRACUNIT*30,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY
}

/*freeslot("SKINCOLOR_ENGINEERING") //An apptempt to make a CF color
skincolors[SKINCOLOR_ENGINEERING] = { 
	name = "CF_Engineering",
	ramp = {52,53,54,55,56,67,68,69,70,71,46,47,47,47,47,47},
	invcolor = SKINCOLOR_WAVE,
	invshade = 6, 
	chatcolor = V_ORANGEMAP,
	accessible = true
}
freeslot("SKINCOLOR_CFIGHTER") //Failure
local colTable = {
	[SKINCOLOR_CFIGHTER] = true
}
rawset(_G, "CLONE_ColorTable", colTable) 
if skincolors[SKINCOLOR_CFIGHTER].name
	table.insert(CLONE_ColorTable, SKINCOLOR_ENGINEERING, true)
end	*/
states[S_BUILD_BOX] = {SPR_BBOX, A, 2, nil, 0, 0, S_BUILD_BOX}

states[S_SENTRY_1] = {SPR_SEN1, A, 2, nil, 0, 0, S_SENTRY_1}
states[S_SENTRY_2] = {SPR_SEN1, B, 3, nil, 0, 0, S_SENTRY_1}
states[S_SENTRY_3] = {SPR_SEN1, C, 2, nil, 0, 0, S_SENTRY_1}
states[S_SENTRY_4] = {SPR_SEN1, C, 2, nil, 0, 0, S_SENTRY_2}

states[S_DISPENSER] = {SPR_DIS1, A, 2, nil, 0, 0, S_DISPENSER}

states[S_TP_1] = {SPR_TP__, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_TP_1}
states[S_TP_2] = {SPR_TP__, B|FF_FULLBRIGHT, 4, nil, 0, 0, S_TP_2}

states[S_MARK_ARROW] = {SPR_MARK, A|FF_FULLBRIGHT, 150, nil, 0, 0, S_NULL}
states[S_MARK_RET] = {SPR_MARK, E|FF_FULLBRIGHT, 150, nil, 0, 0, S_NULL}
states[S_MARK_B1] = {SPR_MARK, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 150, nil, 0, 0, S_NULL}
states[S_MARK_B2] = {SPR_MARK, C|FF_FULLBRIGHT|FF_PAPERSPRITE, 150, nil, 0, 0, S_NULL}
states[S_MARK_B3] = {SPR_MARK, D|FF_FULLBRIGHT|FF_PAPERSPRITE, 150, nil, 0, 0, S_NULL}

local searchRange = 2000*FRACUNIT
local function TF2_SearchForEnemies(src) -- renamed "mo" to "src" so it makes sense
    local tgt -- resulting target mobj
    local lastdist
	if not src.tracer then return end
    
    searchBlockmap("objects", function(_, mobj) -- now looking for objects
        -- we already have our reference object (src), so i don't need that
        
		if not mobj then return end
		if not mobj.valid then return end --ignore if not valid
        if mobj == src.tracer then return end -- ignore if your creator
		if mobj == src then return end -- ignore if same
        if (mobj.health <= 0) then return end -- ignore if dead
		if not P_CheckSight(src,mobj) then return end
        
		if mobj.player
			local bruh
			if (gametyperules & GTR_TEAMS)
				bruh = ((gametyperules & GTR_TEAMS) and mobj.player.ctfteam != src.tracer.player.ctfteam)
			else
				bruh = mobj != src.tracer
			end
		end
        -- attack enemies
        if (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS) -- is a baddie
        or (mobj.player  and mobj.type == MT_PLAYER and mobj.player.playerstate == PST_LIVE and not mobj.player.spectator) and -- is a player, AND
        bruh -- team game, in different teams

            local hdist = R_PointToDist2(mobj.x, mobj.y, src.x, src.y)
            local dist = R_PointToDist2(hdist, mobj.z, 0, src.z)
            
            if dist < searchRange -- within range of our object
            and (lastdist == nil or dist < lastdist) then
                -- this is closer OR we don't have a target yet
                lastdist = dist
                tgt = mobj
				//print(mobj.type)
            end
        end
        
    end,
    src, -- reference object to look around on
    src.x-searchRange,src.x+searchRange,
    src.y-searchRange,src.y+searchRange)
    
    -- searchBlockmap end, we have our thing
    return tgt
end

/*local function TF2_IsAnEnemy(src, mobj)
	local bruh
	if (gametyperules & GTR_TEAMS)
		bruh = ((gametyperules & GTR_TEAMS) and mobj.player.ctfteam != src.tracer.player.ctfteam)
	else
		bruh = mobj != src.tracer
	end
    if (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS) -- is a baddie
    or (mobj.player  and mobj.type == MT_PLAYER and mobj.player.playerstate == PST_LIVE and not mobj.player.spectator) and bruh 
		return true
	end	
end*/

local MARK_SENTRY = 1
local MARK_DISPENS = 2
local MARK_TELEPT = 3

addHook("ThinkFrame", do
	for mo in mobjs.iterate()
		if mo.type == MT_MARKER
			if mo.fuse <= 10
				if mo.tracer
					if mo.marker
						if mo.fuse == 10
							mo.frame = $|FF_TRANS10
						elseif mo.fuse == 9
							mo.frame = $|FF_TRANS20
						elseif mo.fuse == 8
							mo.frame = $|FF_TRANS30
						elseif mo.fuse == 7
							mo.frame = $|FF_TRANS40
						elseif mo.fuse == 6
							mo.frame = $|FF_TRANS50
						elseif mo.fuse == 5
							mo.frame = $|FF_TRANS60
						elseif mo.fuse == 4
							mo.frame = $|FF_TRANS70
						elseif mo.fuse == 3
							mo.frame = $|FF_TRANS80
						elseif mo.fuse == 2
							mo.frame = $|FF_TRANS90
						elseif mo.fuse == 1
							mo.frame = $|FF_TRANS90
							mo.flags2 = $|MF2_DONTDRAW
						end
					else
						if mo.tracer.fuse == 10
							mo.frame = $|FF_TRANS10
						elseif mo.tracer.fuse == 9
							mo.frame = $|FF_TRANS20
						elseif mo.tracer.fuse == 8
							mo.frame = $|FF_TRANS30
						elseif mo.tracer.fuse == 7
							mo.frame = $|FF_TRANS40
						elseif mo.tracer.fuse == 6
							mo.frame = $|FF_TRANS50
						elseif mo.tracer.fuse == 5
							mo.frame = $|FF_TRANS60
						elseif mo.tracer.fuse == 4
							mo.frame = $|FF_TRANS70
						elseif mo.tracer.fuse == 3
							mo.frame = $|FF_TRANS80
						elseif mo.tracer.fuse == 2
							mo.frame = $|FF_TRANS90
						elseif mo.tracer.fuse == 1
							mo.frame = $|FF_TRANS90
							mo.flags2 = $|MF2_DONTDRAW
						end
					end	
				end	
			end	
		end
	end	
end)
rawset(_G, "TF2_FlyTo", function(mo, fx, fy, fz, sped)
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
			
		mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
		mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
		mo.momz = $ + FixedMul(FixedDiv(fz - (mo.z+mo.height), flyto), sped*2)
end)

rawset(_G, "TF2_DistXYZ", function(mo, ax, ay, az)
		local aprx = P_AproxDistance(P_AproxDistance(ax - mo.x, ay - mo.y), az - mo.z)
		if aprx
			return aprx
		end	
end)

local buildtonum = {
	[MT_SENTRY] = 1,
	[MT_DISPENSER] = 2,
	[MT_TP_START] = 3,
	[MT_TP_END] = 4
}

local buildcost = {
	[MT_SENTRY] = 10,
	[MT_DISPENSER] = 25,
	[MT_TP_START] = 5,
	[MT_TP_END] = 5
}

local numtoframe = {
	[0] = C,
	[1] = D,
	[2] = E,
	[3] = F,
	[4] = G,
	[5] = H,
	[6] = I,
	[7] = J,
	[8] = K,
	[9] = L}

local function TF2_DrawNum3D(mo, num, num2)
	local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
	ring.tics = 2
	ring.fuse = 2
	ring.target = mo
	ring.state = S_THOK
	ring.sprite = SPR_DIS1
	ring.frame = B|FF_TRANS30
	ring.spriteyoffset = 5*FRACUNIT
	if num
		if num and num < 10
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
		end	
		if num >= 10 and num < 20
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[1]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
		end	
		if num >= 20 and num < 30
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[2]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
		end	
		
		local numbah = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		numbah.tics = 2
		numbah.fuse = 2
		numbah.target = mo
		numbah.state = S_THOK
		numbah.sprite = SPR_DIS1
		numbah.frame = numtoframe[num%10]|FF_TRANS30
		numbah.spritexoffset = -19*FRACUNIT
	else
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
			if (leveltime%2) == 1
				ring.colorized = true
				ring.color = SKINCOLOR_RED
			else
				ring.colorized = false
			end	
			local numbah = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		numbah.tics = 2
		numbah.fuse = 2
		numbah.target = mo
		numbah.state = S_THOK
		numbah.sprite = SPR_DIS1
		numbah.frame = numtoframe[0]|FF_TRANS30
		numbah.spritexoffset = -19*FRACUNIT
		if (leveltime%2) == 1
			numbah.colorized = true
			numbah.color = SKINCOLOR_RED
		else
			numbah.colorized = false
		end	
	end
	
	if num2
		local dot = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		dot.tics = 2
		dot.fuse = 2
		dot.target = mo
		dot.state = S_THOK
		dot.sprite = SPR_DIS1
		dot.frame = M|FF_TRANS30
		dot.spritexoffset = -12*FRACUNIT
		dot.spriteyoffset = 17*FRACUNIT
		dot.colorized = true
		dot.color = SKINCOLOR_BLUE
		if num2%60 == 60 or num2%60 == 0
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 and num2%60 < 10
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 >= 10 and num2%60 < 20
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[1]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 >= 20 and num2%60 < 30
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[2]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 >= 30 and num2%60 < 40
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[3]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 >= 40 and num2%60 < 50
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[4]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2%60 >= 50 and num2%60 < 60
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[5]|FF_TRANS30
			ring.spritexoffset = -24*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end	
		if num2 < 60
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end
		if num2 >= 60 and num2 < 70
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[1]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end
		if num2 >= 70 and num2 < 80
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[2]|FF_TRANS30
			ring.spritexoffset = -2*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			ring.color = SKINCOLOR_BLUE
		end
		
		local numbah = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		numbah.tics = 2
		numbah.fuse = 2
		numbah.target = mo
		numbah.state = S_THOK
		numbah.sprite = SPR_DIS1
		numbah.frame = numtoframe[num2%10]|FF_TRANS30
		numbah.spritexoffset = -39*FRACUNIT
		numbah.spriteyoffset = 17*FRACUNIT
		numbah.colorized = true
		numbah.color = SKINCOLOR_BLUE
	else
			local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
			ring.tics = 2
			ring.fuse = 2
			ring.target = mo
			ring.state = S_THOK
			ring.sprite = SPR_DIS1
			ring.frame = numtoframe[0]|FF_TRANS30
			ring.spritexoffset = -22*FRACUNIT
			ring.spriteyoffset = 17*FRACUNIT
			ring.colorized = true
			if (leveltime%2) == 1
				ring.color = SKINCOLOR_RED
			else
				ring.color = SKINCOLOR_BLUE
			end	
			local numbah = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
		numbah.tics = 2
		numbah.fuse = 2
		numbah.target = mo
		numbah.state = S_THOK
		numbah.sprite = SPR_DIS1
		numbah.frame = numtoframe[0]|FF_TRANS30
		numbah.spritexoffset = -39*FRACUNIT
		numbah.spriteyoffset = 17*FRACUNIT
		numbah.colorized = true
		if (leveltime%2) == 1
			numbah.color = SKINCOLOR_RED
		else
			numbah.color = SKINCOLOR_BLUE
		end	
	end	
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.tracer and mo.tracer.valid
	and (mo.type == MT_SENTRY
	or mo.type == MT_DISPENSER
	or mo.type == MT_TP_START
	or mo.type == MT_TP_END)
		local enemy = TF2_SearchForEnemies(mo)
			if mo.type == MT_SENTRY
			and mo.valid
				mo.roccd = $ or 0
				mo.death = $ or 0
				mo.color = mo.tracer.color
				local function TF2_ShootRocket(mo, die)
							if not mo.notice
								mo.notice = true
								S_StartSound(mo, sfx_senalr)
							end
							mo.angle = R_PointToAngle2(mo.x, mo.y, die.x, die.y)
							if not mo.roccd
								local roc = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_TORPEDO)
								roc.tracer = die
								roc.target = mo.tracer
								roc.sentryrocket = true
								S_StartSound(mo, sfx_senroc)
								mo.roccd = TICRATE
							end
				end
				if mo.roccd
					mo.roccd = $ - 1
					if mo.roccd > 33
						mo.state = S_SENTRY_4
					else
						mo.state = S_SENTRY_2
					end
				else
					mo.state = S_SENTRY_2
				end
				if mo.death and mo.death > 2
					TF2_FlyTo(mo, mo.tracer.x + FixedMul(15*FRACUNIT, cos(mo.tracer.angle-ANGLE_135)), mo.tracer.y + FixedMul(15*FRACUNIT, sin(mo.tracer.angle-ANGLE_135)), mo.tracer.z + mo.tracer.height + 15*FRACUNIT, FRACUNIT/2)
					mo.flags = $|MF_NOGRAVITY
				else
					mo.flags = $ & ~MF_NOGRAVITY
				end	
				if enemy and enemy.valid
					TF2_ShootRocket(mo, enemy)
				else
					mo.angle = mo.tracer.angle
					mo.notice = false
				end
				if mo.death
					mo.death = $ - 1
					mo.dieing = true
				else
					if mo.dieing
						mo.dieing = false
						for i = 1, 4
							if mo.tracer.player.builds[i] == mo
								mo.tracer.player.builds[i] = nil
							end
						end
						if P_RandomRange(1, 2) == 1
							mo.ranroll = -1
						else
							mo.ranroll = 1
						end
						S_StartSound(mo.tracer, sfx_alart, mo.tracer.player)
						mo.omewushinderu = TICRATE*3
					end
				end
			end
			if mo.type == MT_DISPENSER
			and mo.valid
				mo.color = mo.tracer.color
				mo.storedrings = $ or 0
				mo.death = $ or 0
				mo.ringgive = $ or 0
				//print(mo.storedrings)
				if mo.ringgive
					mo.ringgive = $ - 1
				end
					for player in players.iterate()
						if player.valid and player.playerstate == PST_LIVE
							local dist = R_PointToDist2(R_PointToDist2(player.mo.x, player.mo.y, mo.x, mo.y), player.mo.z, 0, mo.z)
							if dist <= 250*FRACUNIT
							and mo.storedrings
								if not mo.ringgive
									player.rings = $ + 1
									mo.storedrings = $ - 1
									mo.ringgive = 20
								end
								if not S_SoundPlaying(mo, sfx_dishel)
									S_StartSound(mo, sfx_dishel)
								end
							end
						end	
					end
				if not S_SoundPlaying(mo, sfx_disstd)
					S_StartSound(mo, sfx_disstd)
				end
				if mo.death
					TF2_DrawNum3D(mo, abs(mo.storedrings), mo.death/TICRATE)
					if (mo.death%TICRATE) == 1
						S_StartSound(mo, sfx_genmet)
					end
				else
					TF2_DrawNum3D(mo, 0, mo.omewushinderu/TICRATE)
				end	
				if not mo.storedrings
				and mo.dieing
					mo.death = 0
				end
				P_LookForPlayers(mo, 15*FRACUNIT, false)
				if mo.target and mo.target.valid
				and mo.target.player and not mo.nocar
					if R_PointToDist2(mo.z + mo.height, 0, mo.target.z, 0) < 10*FRACUNIT
					and R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) < 15*FRACUNIT
					and mo.target.momz < 0
						mo.carry = mo.target
					end
				end
				if mo.nocar
					mo.nocar = $ - 1
				end
				if mo.carry and mo.carry.valid and mo.carry.player
				and mo.carry.player.valid and mo.carry.player.playerstate == PST_LIVE
					mo.carry.player.powers[pw_carry] = CR_GENERIC
					mo.carry.momz = 0
					mo.carry.momx = 0
					mo.carry.momy = 0
					if mo.carry.state != S_PLAY_WAIT
						mo.carry.state = S_PLAY_WAIT
					end	
					P_TeleportMove(mo.carry, mo.x, mo.y, mo.z+mo.height+5*FRACUNIT)
					if mo.carry.player.cmd.buttons & BT_JUMP
						if not mo.carry.jup
							P_SetObjectMomZ(mo.carry, 5*FRACUNIT, true)
							P_DoJump(mo.carry.player)
							mo.carry.player.powers[pw_carry] = 0
							mo.flymychild = true
							mo.nocar = 15
						end
						mo.carry.jup = true
					else
						mo.carry.jup = false
					end
					if mo.flymychild
						mo.carry = nil
						mo.flymychild = false
					end
				end
				if mo.death
					mo.death = $ - 1
					mo.dieing = true
				else
					if mo.dieing
						mo.dieing = false
						for i = 1, 4
							if mo.tracer.player.builds[i] == mo
								mo.tracer.player.builds[i] = nil
							end
						end
						if P_RandomRange(1, 2) == 1
							mo.ranroll = -1
						else
							mo.ranroll = 1
						end
						P_SetObjectMomZ(mo, 8*FRACUNIT)
						S_StartSound(mo.tracer, sfx_alart, mo.tracer.player)
						mo.flags = MF_SCENERY
						if mo.storedrings
							mo.omewushinderu = TICRATE
						else
							mo.omewushinderu = TICRATE*5
							mo.storedrings = 0
						end	
					end	
				end	
			end
			if (mo.type == MT_TP_START
			or mo.type == MT_TP_END)
			and mo.valid
				mo.color = mo.tracer.color
				if mo.type == MT_TP_START
					if mo.tracer.player.builds[4] and mo.tracer.player.builds[4].valid
					and not mo.join and mo.tracer.player.builds[4].type == MT_TP_END
						mo.join = mo.tracer.player.builds[4]
					end
				else
					if mo.tracer.player.builds[3] and mo.tracer.player.builds[3].valid
					and not mo.join and mo.tracer.player.builds[3].type == MT_TP_START
						mo.join = mo.tracer.player.builds[3]
					end
				end
				if mo.join
				and mo.type == MT_TP_START
					local arewethereyet = P_SpawnMobjFromMobj(mo, 0, 0, 6*FRACUNIT, MT_EFFECT)
					arewethereyet.flags = $|MF_NOGRAVITY
					arewethereyet.fuse = 2
					arewethereyet.sprite = SPR_TP__
					arewethereyet.frame = C
					arewethereyet.tics = -1
					arewethereyet.flags2 = $|MF2_SPLAT
					arewethereyet.renderflags = $|RF_NOSPLATBILLBOARD
					arewethereyet.color = mo.color
					arewethereyet.rollangle = R_PointToAngle2(mo.x, mo.y, mo.join.x, mo.join.y)
				end
				if mo.cooldown
					mo.cooldown = $ - 1
					if mo.cooldown == 1
						mo.tping = 2*TICRATE
						S_StartSound(mo, sfx_tpred)
					end
					if S_SoundPlaying(mo, sfx_tpspn)
						S_StopSoundByID(mo, sfx_tpspn)
					end
				else
					if mo.join
						if not S_SoundPlaying(mo, sfx_tpspn)
							S_StartSound(mo, sfx_tpspn)
						end
					end	
				end
				if not mo.main
					mo.main = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EFFECT)
					mo.main.state = S_TP_1
					mo.main.flags2 = $|MF2_SPLAT
					mo.main.flags = MF_SCENERY|MF_NOGRAVITY
					mo.main.color = mo.color
					mo.main.renderflags = $|RF_NOSPLATBILLBOARD
				else
					mo.main.state = S_TP_1
					mo.main.color = mo.color
					mo.main.flags2 = $|MF2_SPLAT
					mo.main.flags = MF_SCENERY|MF_NOGRAVITY
					mo.main.renderflags = $|RF_NOSPLATBILLBOARD
					//mo.main.spriteyoffset = -4*FRACUNIT
					P_TeleportMove(mo.main, mo.x, mo.y, mo.z + (5*FRACUNIT*P_MobjFlip(mo)))
				end	
				mo.flags2 = $|MF2_SPLAT
				mo.renderflags = $|RF_NOSPLATBILLBOARD
				if not mo.rotsped
					mo.rotsped = 5
				end
				if mo.rotsped > 30
					mo.rotsped = 30
				end
				if mo.rotsped < 5
					mo.rotsped = 5
				end
				if mo.main
					if (mo.join and mo.join.valid)
						if not (mo.cooldown or mo.join.cooldown)
							mo.rotsped = $ + 2
							if mo.rotsped
								mo.main.rollangle = $ + (mo.rotsped*ANG1)
							end
							local notyet = P_SpawnMobjFromMobj(mo, 0, 0, 7*FRACUNIT, MT_EFFECT)
							notyet.flags = $|MF_NOGRAVITY
							notyet.fuse = 2
							notyet.sprite = SPR_THOK
							notyet.frame = A|FF_TRANS20
							notyet.tics = -1
							notyet.flags2 = $|MF2_SPLAT
							notyet.renderflags = $|RF_NOSPLATBILLBOARD
							notyet.scale = FRACUNIT/2*3
							notyet.spriteyoffset = (-23*FRACUNIT)
							notyet.color = mo.color
							notyet.rollangle = (leveltime%360)*ANG1*30
						else
							if mo.rotsped
								mo.main.rollangle = $ + (mo.rotsped*ANG1)
							end
						end
						if mo.cooldown
							mo.rotsped = $ - 2
						end
					end	
				end	
				if mo.tping == nil
					mo.tping = 2*TICRATE
				end
				if mo.fuckgoback == nil
					mo.fuckgoback = 0
				end
				if mo.fuckgoback
					mo.fuckgoback = $ - 1
				end
				P_LookForPlayers(mo, 50*FRACUNIT, false)
				if mo.tping < 2*TICRATE
				and not mo.fuckgoback
					mo.tping = $ + 1
				end
				if mo.target and mo.target.valid
				and mo.type == MT_TP_START
				and mo.target.player 
				and R_PointToDist2(R_PointToDist2(mo.target.x, mo.target.y, mo.x, mo.y), mo.target.z, 0, mo.z) <= 50*FRACUNIT
				and not mo.cooldown and mo.join
				and P_IsObjectOnGround(mo.target)
					mo.tping = $ - 1
					mo.fuckgoback = 5
					if (mo.tping%5) == 1
						local ghost = P_SpawnGhostMobj(mo.target)
						ghost.colorized = true
						ghost.color = P_RandomRange(1, #skincolors-1)
						ghost.blendmode = AST_ADD
						ghost.scale = FRACUNIT + (FRACUNIT/35*mo.tping)
						ghost.destscale = FRACUNIT
						ghost.tics = 15
						
						ghost.tracer.colorized = true
						ghost.tracer.color = P_RandomRange(1, #skincolors-1)
						ghost.tracer.blendmode = AST_ADD
						ghost.tracer.scale = FRACUNIT + (FRACUNIT/35*mo.tping)
						ghost.tracer.destscale = FRACUNIT
						ghost.tracer.tics = 15
					end	
					if mo.tping == 1
						mo.tping = 0
						for flashbang in players.iterate()
							if flashbang and flashbang.valid
							and flashbang.mo != mo.target
							and R_PointToDist2(mo.x, mo.y, flashbang.mo.x, flashbang.mo.y) <= 1000*FRACUNIT
							and P_CheckSight(flashbang.mo, mo.target)
								P_FlashPal(flashbang, 1, 5)
							end
						end
						P_FlashPal(mo.target.player, 1, 5)
						S_StartSound(mo, sfx_tpsed)
						P_TeleportMove(mo.target, mo.join.x, mo.join.y, mo.join.z + 5*FRACUNIT)
						S_StartSound(mo.join, sfx_tpgot)
						mo.cooldown = 5*TICRATE
						//mo.join.cooldown = 5*TICRATE
						local ghost = P_SpawnGhostMobj(mo.target)
						ghost.colorized = true
						ghost.color = SKINCOLOR_WHITE
						ghost.tics = TICRATE
						if mo.tpyes
							mo.tpyes = $ + 1
						else
							mo.tpyes = 1
						end
					end	
				end
			end
		if mo.tracer.skin != "engitails"
		or mo.spectator
			if mo.tracer.builds
				mo.tracer.builds[buildtonum[mo.type]] = nil
			end	
			P_KillMobj(mo, mo.tracer, mo.tracer)
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.valid and mo.tracer and mo.tracer.valid
		local timerot = ((leveltime%360))*ANG1
		if mo.type == MT_BUILD_BOX
			mo.build = $ or 0
			if P_IsObjectOnGround(mo)
				if mo.stopmom
					mo.stopmom = false
					mo.momx = $/5
					mo.momy = $/5
					S_StartSound(mo, hitgrd[P_RandomRange(1, 8)])
				end
				if mo.build
					mo.build = $ + 1
					mo.buiding = true
					mo.spriteyscale = FRACUNIT + FixedMul(cos((mo.build*ANG1*3) - ANGLE_90), FRACUNIT/2)
					mo.spritexscale = FRACUNIT - FixedMul(cos((mo.build*ANG1*3) - ANGLE_90), FRACUNIT/2)
					if mo.build > TICRATE
						mo.build = 0
					end
				else
					if mo.buiding
						mo.buiding = false
						if mo.lebuild
							local build = P_SpawnMobjFromMobj(mo, 0, 0, 0, mo.lebuild)
							build.tracer = mo.tracer
							build.target = mo.tracer
							mo.tracer.player.builds[buildtonum[mo.lebuild]] = build
							//mo.tracer.player.rings = $ - 1
							if buildtonum[mo.lebuild] == 1
								build.death = 10*TICRATE
							end
							if buildtonum[mo.lebuild] == 2
								build.death = 65*TICRATE //35 Second until Self-Detonation
								build.storedrings = 25
							end
							if buildtonum[mo.lebuild] == 3
								if mo.tracer.player.builds[4] and mo.tracer.player.builds[4].valid
									mo.join = mo.tracer.player.builds[4]
								end
							end
							if buildtonum[mo.lebuild] == 4
								if mo.tracer.player.builds[3] and mo.tracer.player.builds[3].valid
									mo.join = mo.tracer.player.builds[3]
								end
							end
							//mo.tracer.player.rings = $ - buildcost[mo.lebuild]
							S_StartSound(mo, sfx_budfin)
							P_SetObjectMomZ(build, 5*FRACUNIT)
						end	
						local ex = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
						ex.scale = FRACUNIT*2
						mo.flags2 = MF2_DONTDRAW
						mo.flags = MF_NOTHINK|MF_SCENERY
					end
				end
			end	
		end
		if mo.type == MT_MARKER
			if mo.marker
				mo.spriteyoffset = FixedMul(5*FRACUNIT, cos(timerot*5))
				local ret = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_MARKER)
				ret.fuse = 2
				ret.tics = 2
				ret.renderflags = $|RF_NOSPLATBILLBOARD
				ret.flags2 = mo.flags2|MF2_SPLAT
				ret.angle = timerot*5
				ret.frame = mo.frame
				ret.color = mo.color
				ret.scale = FRACUNIT + FixedMul(FRACUNIT/3, cos(timerot*5))
				ret.state = S_MARK_RET
				ret.tracer = mo
				if mo.marker == MARK_SENTRY
					local mark = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_MARKER)
					mark.fuse = 2
					mark.tics = 2
					mark.flags2 = mo.flags2
					mark.angle = timerot*10
					mark.frame = mo.frame|FF_PAPERSPRITE
					mark.color = mo.color
					mark.spriteyoffset = FixedMul(5*FRACUNIT, cos(timerot*5))
					mark.state = S_MARK_B1
					mark.tracer = mo
					mark.scale = (FRACUNIT/2*3) + FixedMul(cos(timerot*5), FRACUNIT/2)
				end
				if mo.marker == MARK_DISPENS
					local mark = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_MARKER)
					mark.fuse = 2
					mark.tics = 2
					mark.angle = timerot*10
					mark.frame = mo.frame|FF_PAPERSPRITE
					mark.flags2 = mo.flags2
					mark.color = mo.color
					mark.spriteyoffset = FixedMul(5*FRACUNIT, cos(timerot*5))
					mark.state = S_MARK_B2
					mark.tracer = mo
					mark.scale = (FRACUNIT/2*3) + FixedMul(cos(timerot*5), FRACUNIT/2)
				end
				if mo.marker == MARK_TELEPT
					local mark = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_MARKER)
					mark.fuse = 2
					mark.tics = 2
					mark.angle = timerot*10
					mark.frame = mo.frame|FF_PAPERSPRITE
					mark.flags2 = mo.flags2
					mark.color = mo.color
					mark.spriteyoffset = FixedMul(5*FRACUNIT, cos(timerot*5))
					mark.state = S_MARK_B3
					mark.tracer = mo
					mark.scale = (FRACUNIT/2*3) + FixedMul(cos(timerot*5), FRACUNIT/2)
				end
			end
		end
		if mo.type == MT_TORPEDO
		and mo.sentryrocket
			P_HomingAttack(mo, mo.tracer)
		end
	end	
	if mo.valid
		if mo.omewushinderu
			mo.omewushinderu = $ - 1
			mo.flags = MF_SCENERY
			if mo.ranroll and mo.type == MT_SENTRY
				mo.rollangle = $ + mo.momz/FRACUNIT*ANG1*mo.ranroll
			end
			mo.spriteyoffset = FRACUNIT - FixedMul(cos(mo.omewushinderu*ANG1*30), FRACUNIT/2)
			mo.spritexoffset = FRACUNIT - FixedMul(cos(mo.omewushinderu*ANG1*15), FRACUNIT/2)
			if (mo.omewushinderu%2) == 1
				mo.colorized = true
			else
				mo.colorized = false
			end
			if mo.omewushinderu == 1
			or (P_IsObjectOnGround(mo) and mo.type == MT_SENTRY)
				mo.omewushinderu = 0
				if mo.storedrings
					if mo.storedrings >= 2
						for i = 1, mo.storedrings
							local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_FLINGRING)
							//ring.flags = MF_SCENERY|MF_SPECIAL
							ring.fuse = 5*TICRATE
							ring.tics = 5*TICRATE
							P_SetObjectMomZ(ring, P_RandomRange(0, 10)*FRACUNIT)
							P_InstaThrust(ring, P_RandomRange(1, 360)*ANG1, P_RandomRange(0, 5)*FRACUNIT)
						end
					else
						local ring = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_FLINGRING)
						ring.fuse = 5*TICRATE
						ring.tics = 5*TICRATE
						P_SetObjectMomZ(ring, P_RandomRange(0, 10)*FRACUNIT)
						P_InstaThrust(ring, P_RandomRange(1, 360)*ANG1, P_RandomRange(0, 5)*FRACUNIT)
					end	
				end
				P_KillMobj(mo)
			end
		end
	end
end)

local mobjtosound = {
	[MT_SENTRY] = sfx_senexp,
	[MT_DISPENSER] = sfx_disexp,
	[MT_TP_START] = sfx_tpexp,
	[MT_TP_END] = sfx_tpexp
}

addHook("MobjDeath", function(mo, inf, source)
	if mo and mo.tracer
		if (mo.type == MT_SENTRY
		or mo.type == MT_DISPENSER
		or mo.type == MT_TP_START
		or mo.type == MT_TP_END)
			local exp = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
			exp.scale = FRACUNIT*2
			exp.colorized = true
			local randomexp = {SKINCOLOR_RED, SKINCOLOR_CRIMSON, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW, SKINCOLOR_COPPER}
			exp.color = randomexp[P_RandomRange(1, 5)]
			local beeg = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
			beeg.state = S_TNTBARREL_EXPL1
			beeg.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			beeg.fuse = 50
			for i = 1, 10
				local dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUST)
				P_InstaThrust(dust, P_RandomRange(0, 360)*ANG1, P_RandomRange(5, 8)*FRACUNIT)
				P_SetObjectMomZ(dust, P_RandomRange(-8, 8)*FRACUNIT)
			end
			local smoke = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_EXPLODE)
			smoke.state = S_ARIDDUST1
			smoke.fuse = P_RandomRange(15, 50)
			smoke.momx = P_RandomRange(0, 5)*FRACUNIT
			smoke.momy = P_RandomRange(0, 5)*FRACUNIT
			local sound = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			sound.tics = TICRATE*10
			sound.fuse = TICRATE*10
			sound.flags2 = MF2_DONTDRAW
			sound.flags = MF_SCENERY|MF_NOTHINK
			S_StartSound(sound, mobjtosound[mo.type])
		end
	end
end)